#ifndef OOPSMP_MOTION_PLANNERS_TREE_PLANNER_RRT_DDRRT__OOPSMP_DDRRT_H_
#define OOPSMP_MOTION_PLANNERS_TREE_PLANNER_RRT_DDRRT__OOPSMP_DDRRT_H_

#include "MotionPlanners/TreePlanner/RRT/OOPSMPRRT.H"

#define DEFAULT_DDRRT_RADIUS  0.1

namespace OOPSMP
{
    ForwardClassDeclaration(DDRRT);

    class DDRRT : public RRT
    {
    protected:
	double m_radius;

    public:
	
	ForwardClassDeclaration(DDRRTVertexData);

	class DDRRTVertexData : public VertexData
	{
	protected:
	    double m_radius;

	public:
	    friend class DDRRT;

	    DDRRTVertexData( const int id=1, State_t x= NULL ) : VertexData( id, x )
	    {
		m_radius = HUGE_VAL;
	    }

	    virtual ~DDRRTVertexData( void )
	    {}

	    virtual double getRadius(void)
	    {
		return m_radius;
	    }

	    virtual void setRadius( double new_radius )
	    {
		m_radius = new_radius;
	    }
	};
	
	DDRRT();

	virtual ~DDRRT( void )
	{}

	virtual double getRadius( void ) const
	{
	    return m_radius;
	}

	void setRadius( const double r )
	{
	    m_radius = r;
	    printf( "I set the RADIUS\n");
	}

	virtual GraphVertexData_t createVertexData( void ) const
	{
	    return new DDRRTVertexData();
	}

	void iterate();
    };
    
    DeclareInstanceFactory(DDRRT, RRTFactory);
}

#endif

